/* DbObject.c generated by valac 0.16.0, the Vala compiler
 * generated from DbObject.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * libgdadata
 * Copyright (C) Daniel Espinosa Ortiz 2011 <esodan@gmail.com>
 * 
 * libgda is free software: you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * libgda is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <libgda/libgda.h>
#include <stdlib.h>
#include <string.h>


#define GDA_DATA_TYPE_DB_OBJECT (gda_data_db_object_get_type ())
#define GDA_DATA_DB_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GDA_DATA_TYPE_DB_OBJECT, GdaDataDbObject))
#define GDA_DATA_IS_DB_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GDA_DATA_TYPE_DB_OBJECT))
#define GDA_DATA_DB_OBJECT_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GDA_DATA_TYPE_DB_OBJECT, GdaDataDbObjectIface))

typedef struct _GdaDataDbObject GdaDataDbObject;
typedef struct _GdaDataDbObjectIface GdaDataDbObjectIface;

#define GDA_DATA_TYPE_DB_NAMED_OBJECT (gda_data_db_named_object_get_type ())
#define GDA_DATA_DB_NAMED_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GDA_DATA_TYPE_DB_NAMED_OBJECT, GdaDataDbNamedObject))
#define GDA_DATA_IS_DB_NAMED_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GDA_DATA_TYPE_DB_NAMED_OBJECT))
#define GDA_DATA_DB_NAMED_OBJECT_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GDA_DATA_TYPE_DB_NAMED_OBJECT, GdaDataDbNamedObjectIface))

typedef struct _GdaDataDbNamedObject GdaDataDbNamedObject;
typedef struct _GdaDataDbNamedObjectIface GdaDataDbNamedObjectIface;

struct _GdaDataDbObjectIface {
	GTypeInterface parent_iface;
	void (*append) (GdaDataDbObject* self, GError** error);
	void (*update) (GdaDataDbObject* self, GError** error);
	void (*save) (GdaDataDbObject* self, GError** error);
	void (*drop) (GdaDataDbObject* self, gboolean cascade, GError** error);
	GdaConnection* (*get_connection) (GdaDataDbObject* self);
	void (*set_connection) (GdaDataDbObject* self, GdaConnection* value);
	gboolean (*get_update_meta) (GdaDataDbObject* self);
	void (*set_update_meta) (GdaDataDbObject* self, gboolean value);
};

struct _GdaDataDbNamedObjectIface {
	GTypeInterface parent_iface;
	const gchar* (*get_name) (GdaDataDbNamedObject* self);
	void (*set_name) (GdaDataDbNamedObject* self, const gchar* value);
};

typedef enum  {
	GDA_DATA_DB_OBJECT_ERROR_APPEND,
	GDA_DATA_DB_OBJECT_ERROR_UPDATE,
	GDA_DATA_DB_OBJECT_ERROR_SAVE,
	GDA_DATA_DB_OBJECT_ERROR_DROP
} GdaDataDbObjectError;
#define GDA_DATA_DB_OBJECT_ERROR gda_data_db_object_error_quark ()


GType gda_data_db_object_get_type (void) G_GNUC_CONST;
void gda_data_db_object_append (GdaDataDbObject* self, GError** error);
void gda_data_db_object_update (GdaDataDbObject* self, GError** error);
void gda_data_db_object_save (GdaDataDbObject* self, GError** error);
void gda_data_db_object_drop (GdaDataDbObject* self, gboolean cascade, GError** error);
GdaConnection* gda_data_db_object_get_connection (GdaDataDbObject* self);
void gda_data_db_object_set_connection (GdaDataDbObject* self, GdaConnection* value);
gboolean gda_data_db_object_get_update_meta (GdaDataDbObject* self);
void gda_data_db_object_set_update_meta (GdaDataDbObject* self, gboolean value);
GType gda_data_db_named_object_get_type (void) G_GNUC_CONST;
const gchar* gda_data_db_named_object_get_name (GdaDataDbNamedObject* self);
void gda_data_db_named_object_set_name (GdaDataDbNamedObject* self, const gchar* value);
GQuark gda_data_db_object_error_quark (void);


void gda_data_db_object_append (GdaDataDbObject* self, GError** error) {
	g_return_if_fail (self != NULL);
	GDA_DATA_DB_OBJECT_GET_INTERFACE (self)->append (self, error);
}


void gda_data_db_object_update (GdaDataDbObject* self, GError** error) {
	g_return_if_fail (self != NULL);
	GDA_DATA_DB_OBJECT_GET_INTERFACE (self)->update (self, error);
}


void gda_data_db_object_save (GdaDataDbObject* self, GError** error) {
	g_return_if_fail (self != NULL);
	GDA_DATA_DB_OBJECT_GET_INTERFACE (self)->save (self, error);
}


void gda_data_db_object_drop (GdaDataDbObject* self, gboolean cascade, GError** error) {
	g_return_if_fail (self != NULL);
	GDA_DATA_DB_OBJECT_GET_INTERFACE (self)->drop (self, cascade, error);
}


GdaConnection* gda_data_db_object_get_connection (GdaDataDbObject* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return GDA_DATA_DB_OBJECT_GET_INTERFACE (self)->get_connection (self);
}


void gda_data_db_object_set_connection (GdaDataDbObject* self, GdaConnection* value) {
	g_return_if_fail (self != NULL);
	GDA_DATA_DB_OBJECT_GET_INTERFACE (self)->set_connection (self, value);
}


gboolean gda_data_db_object_get_update_meta (GdaDataDbObject* self) {
	g_return_val_if_fail (self != NULL, FALSE);
	return GDA_DATA_DB_OBJECT_GET_INTERFACE (self)->get_update_meta (self);
}


void gda_data_db_object_set_update_meta (GdaDataDbObject* self, gboolean value) {
	g_return_if_fail (self != NULL);
	GDA_DATA_DB_OBJECT_GET_INTERFACE (self)->set_update_meta (self, value);
}


static void gda_data_db_object_base_init (GdaDataDbObjectIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
		g_object_interface_install_property (iface, g_param_spec_object ("connection", "connection", "connection", gda_connection_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
		/**
		 * update_meta:
		 *
		 * Set to true if you want to update Gda.MetaStore information.
		 *
		 * Implementation: Set to false as default and reset it to false when update() is finished.
		 */
		g_object_interface_install_property (iface, g_param_spec_boolean ("update-meta", "update-meta", "update-meta", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	}
}


GType gda_data_db_object_get_type (void) {
	static volatile gsize gda_data_db_object_type_id__volatile = 0;
	if (g_once_init_enter (&gda_data_db_object_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GdaDataDbObjectIface), (GBaseInitFunc) gda_data_db_object_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType gda_data_db_object_type_id;
		gda_data_db_object_type_id = g_type_register_static (G_TYPE_INTERFACE, "GdaDataDbObject", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (gda_data_db_object_type_id, G_TYPE_OBJECT);
		g_once_init_leave (&gda_data_db_object_type_id__volatile, gda_data_db_object_type_id);
	}
	return gda_data_db_object_type_id__volatile;
}


const gchar* gda_data_db_named_object_get_name (GdaDataDbNamedObject* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return GDA_DATA_DB_NAMED_OBJECT_GET_INTERFACE (self)->get_name (self);
}


void gda_data_db_named_object_set_name (GdaDataDbNamedObject* self, const gchar* value) {
	g_return_if_fail (self != NULL);
	GDA_DATA_DB_NAMED_OBJECT_GET_INTERFACE (self)->set_name (self, value);
}


static void gda_data_db_named_object_base_init (GdaDataDbNamedObjectIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
		g_object_interface_install_property (iface, g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	}
}


GType gda_data_db_named_object_get_type (void) {
	static volatile gsize gda_data_db_named_object_type_id__volatile = 0;
	if (g_once_init_enter (&gda_data_db_named_object_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GdaDataDbNamedObjectIface), (GBaseInitFunc) gda_data_db_named_object_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType gda_data_db_named_object_type_id;
		gda_data_db_named_object_type_id = g_type_register_static (G_TYPE_INTERFACE, "GdaDataDbNamedObject", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (gda_data_db_named_object_type_id, G_TYPE_OBJECT);
		g_type_interface_add_prerequisite (gda_data_db_named_object_type_id, GDA_DATA_TYPE_DB_OBJECT);
		g_once_init_leave (&gda_data_db_named_object_type_id__volatile, gda_data_db_named_object_type_id);
	}
	return gda_data_db_named_object_type_id__volatile;
}


GQuark gda_data_db_object_error_quark (void) {
	return g_quark_from_static_string ("gda_data_db_object_error-quark");
}



